var gSpellChecker = null;

function bOpenSpellCheck() {
  if (popupOn)
    return;

  window.cancelSendMessage = false;
  try {
    var skipBlockQuotes = (window.document.firstChild.getAttribute("windowtype") == "msgcompose");
    window.openDialog("chrome://editor/content/EdSpellCheck.xul", "_blank",
                      "chrome,close,titlebar,modal", false, skipBlockQuotes, true);
  }
  catch(ex) {}
  window.content.focus();
}

function bSpellDropInit() {
  var p = document.getElementById("bSpellDropDown");
  var o1 = {};
  var o2 = {};

  // Get the list of dictionaries from
  // the spellchecker.

  if(!gSpellChecker) {
    gSpellChecker = Components.classes['@mozilla.org/editor/editorspellchecker;1'].createInstance(Components.interfaces.nsIEditorSpellCheck);
    if (!gSpellChecker) {
      dump("SpellChecker not found!!!\n");
      return;
    }
  }

  gSpellChecker.InitSpellChecker(GetCurrentEditor(), true);

  var curLang;

  try {
    curLang = gSpellChecker.GetCurrentDictionary();
  } catch(ex) {
    curLang = "";
  }

  try {
    gSpellChecker.GetDictionaryList(o1, o2);
  } catch(ex) {
    dump("Failed to get DictionaryList!\n");
    return;
  }

  var dictList = o1.value;
  var count  = o2.value;

  // Load the string bundles that will help us map
  // RFC 1766 strings to UI strings.

  // Load the language string bundle.
  var languageBundle = document.getElementById("languageBundle");
  var regionBundle;
  // If we have a language string bundle, load the region string bundle.
  if (languageBundle)
  regionBundle = document.getElementById("regionBundle");

  var menuStr2;
  var isoStrArray;
  var defaultItem = null;
  var langId;
  var i;
  for (i = 0; i < dictList.length; i++) {
    try {
      langId = dictList[i];
      isoStrArray = dictList[i].split("-");

      dictList[i] = new Array(2); // first subarray element - pretty name
      dictList[i][1] = langId;  // second subarray element - language ID

      if (languageBundle && isoStrArray[0])
        dictList[i][0] = languageBundle.getString(isoStrArray[0].toLowerCase());

      if (regionBundle && dictList[i][0] && isoStrArray.length > 1 && isoStrArray[1]) {
        menuStr2 = regionBundle.getString(isoStrArray[1].toLowerCase());
        if (menuStr2)
          dictList[i][0] = dictList[i][0] + "/" + menuStr2;
      }

      if (!dictList[i][0])
      dictList[i][0] = dictList[i][1];
    } catch (ex) {
      // GetString throws an exception when
      // a key is not found in the bundle. In that
      // case, just use the original dictList string.

      dictList[i][0] = dictList[i][1];
    }
  }

  // note this is not locale-aware collation, just simple ASCII-based sorting
  // we really need to add loacel-aware JS collation, see bug XXXXX
  dictList.sort();

  for (i = 0; i < dictList.length; i++) {
    var menuitem = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menuitem");
    menuitem.setAttribute("value", dictList[i][1]);
    menuitem.setAttribute("label", dictList[i][0]);
    menuitem.setAttribute("type", "radio");

    if (curLang && dictList[i][1] == curLang) {
      menuitem.setAttribute("checked", true);
    }

    menuitem.setAttribute("tooltiptext", dictList[i][0]);
    menuitem.setAttribute("oncommand", "bSpellSelectDefault(this);");
    p.appendChild(menuitem);
  }
}

function bSpellSelectDefault(p) {
  if (!gSpellChecker) {
    dump("SpellChecker not found!!!\n");
  } else {
    try {
      gSpellChecker.SetCurrentDictionary(p.value);
      gSpellChecker.UninitSpellChecker();
    }
    catch (ex) {}
    finally { gSpellChecker = null; }
  }

  popupOn = true;
}

function bComposeUndo() {
  goDoCommand('cmd_undo');
}

function bComposeRedo() {
  goDoCommand('cmd_redo');
}

try {
  bOldComposeLoad = ComposeLoad;
  if(bOldComposeLoad) {
    ComposeLoad = function () {
      bOldComposeLoad();
      setTimeout(function () {
        GetCurrentEditor().transactionManager.clear();
        bUpdateUndoButtons(GetCurrentEditor().transactionManager);
        GetCurrentEditor().transactionManager.AddListener(bTransactionListener);
      }, 0);
    }
  }
} catch (ex) {}
