function bRealNavigate(event, dirPrev, srcMain) {
	if(dirPrev) {
		if(srcMain) {
			if (event && event.shiftKey) {
				return MsgPreviousUnreadMessage();
			} else {
				return GoNextMessage(nsMsgNavigationType.previousMessage, false );
			}
		} else {
			if (event && event.shiftKey) {
				return performNavigation(nsMsgNavigationType.previousUnreadMessage);
			} else {
				return LoadMessageByNavigationType(nsMsgNavigationType.previousMessage);
			}
		}
	} else {
		if(srcMain) {
			if (event && event.shiftKey) {
				return MsgNextUnreadMessage();
			} else {
				return GoNextMessage(nsMsgNavigationType.nextMessage, false );
			}
		} else {
			if (event && event.shiftKey) {
				return performNavigation(nsMsgNavigationType.nextUnreadMessage);
			} else {
				return LoadMessageByNavigationType(nsMsgNavigationType.nextMessage);
			}
		}
	}
}

function bToggleHTML() {
  var prefer_plaintext = nsPreferences.getBoolPref("mailnews.display.prefer_plaintext", false);
  var html_as = nsPreferences.getIntPref("mailnews.display.html_as", 0);
  var disallow_classes = nsPreferences.getIntPref("mailnews.display.disallow_mime_handlers", 0);

  var Sanitized_checked = false;
  var AsPlaintext_checked = false;
  if (!prefer_plaintext && html_as == 3 && disallow_classes > 0)
    Sanitized_checked = true;
  else if (prefer_plaintext && html_as == 1 && disallow_classes > 0)
    AsPlaintext_checked = true;

  var htmlSwitch = nsPreferences.getIntPref("buttons.htmlswitch", 0);
  switch (htmlSwitch) {
    case 0:
      if (AsPlaintext_checked)
        MsgBodyAllowHTML();
      else
        MsgBodyAsPlaintext();
      break;
    case 1:
      if (AsPlaintext_checked)
        MsgBodySanitized();
      else
        MsgBodyAsPlaintext();
      break;
    case 2:
      if (Sanitized_checked)
        MsgBodyAllowHTML();
      else
        MsgBodySanitized();
      break;
    default:
      break;
  }
  //bUpdateButtons();
}

function bToggleImages() {
  var showImages = nsPreferences.getBoolPref("mailnews.message_display.disable_remote_image", false);
  nsPreferences.setBoolPref("mailnews.message_display.disable_remote_image", !showImages);
  MsgReload();
  //bUpdateButtons();
}

function bMoveMessage(destUri) {
  try {
    var destResource = RDF.GetResource(destUri);
    var destMsgFolder = destResource.QueryInterface(Components.interfaces.nsIMsgFolder);
  } catch (ex) {
    alert("The folder you selected is invalid.  Please verify that the folder exists or that the correct path is entered in the Buttons! options window.");
    return false;
  }

  if(nsPreferences.getBoolPref("buttons.markreadonarchive", false)) {
    MsgMarkMsgAsRead(true);
  }

  if (isNewsURI(gDBView.msgFolder.URI)) {
    gDBView.doCommandWithFolder(nsMsgViewCommandType.copyMessages, destMsgFolder);
  } else {
    SetNextMessageAfterDelete();
    gDBView.doCommandWithFolder(nsMsgViewCommandType.moveMessages, destMsgFolder);
  }
}

function bArchiveMessageDefault(buttonElem) {
  if (popupOn)
    return;

	var defaultFolder = nsPreferences.getLocalizedUnicharPref("buttons.archive.default", "");
	if(!defaultFolder) {
		document.getElementById("bArchiveDropDown").showPopup();
	} else {
		bMoveMessage(defaultFolder);
	}
}

function bArchiveDropInit() {
	var p = document.getElementById("bArchiveDropDown");
	var folders = nsPreferences.getLocalizedUnicharPref("buttons.archive.folders", "");
	var defaultFolder = nsPreferences.getLocalizedUnicharPref("buttons.archive.default", "");
  var menuitem;
	if(folders) {
		folders = folders.split("///");
		for(var i = 0; i < folders.length; ++i) {
      // parse variables


      // try to add to menu
			var msgFolder = GetMsgFolderFromUri(folders[i], true);
			if(msgFolder) {
				menuitem = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menuitem");
        if(nsPreferences.getBoolPref("buttons.showprettynameinarchive", true)) {
				  menuitem.setAttribute("label", document.getElementById("bundle_messenger").getFormattedString("verboseFolderFormat", [msgFolder.name, msgFolder.server.prettyName]));
        } else {
          menuitem.setAttribute("label", folders[i]);
        }
				menuitem.setAttribute("value", folders[i]);
				menuitem.setAttribute("type", "radio");

				if (defaultFolder && folders[i] == defaultFolder) {
					menuitem.setAttribute("checked", true);
				}

				menuitem.setAttribute("oncommand", "bMoveMessage(this.getAttribute('value'));");

				p.appendChild(menuitem);
			}
		}
	} else {
		menuitem = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menuitem");
		menuitem.setAttribute("label", "(Empty)");
		menuitem.setAttribute("disabled", true);
		p.appendChild(menuitem);
	}
}

function bDeleteThread(event) {
  if(nsPreferences.getBoolPref("buttons.noconfirmondelete", false) || confirm(messages.deleteThreadConfirm)) {
    gDBView.doCommand(nsMsgViewCommandType.selectThread);
		SetNextMessageAfterDelete();
    gDBView.doCommand(nsMsgViewCommandType.deleteMsg);
  }
}

function bUpdateButtons() {
  // add switch statement!
  try {
    var bHTML = document.getElementById("ToggleHTML");
    if(bHTML) {
  		var prefer_plaintext = nsPreferences.getBoolPref("mailnews.display.prefer_plaintext", false);
			var html_as = nsPreferences.getIntPref("mailnews.display.html_as", 0);
			var disallow_classes = nsPreferences.getIntPref("mailnews.display.disallow_mime_handlers", 0);

			var Sanitized_checked = false;
			var AsPlaintext_checked = false;
		  if (!prefer_plaintext && html_as == 3 && disallow_classes > 0)
				Sanitized_checked = true;
			else if (prefer_plaintext && html_as == 1 && disallow_classes > 0)
				AsPlaintext_checked = true;

			var htmlSwitch = nsPreferences.getIntPref("buttons.htmlswitch", 0);
			switch (htmlSwitch) {
        case 0:
          if (AsPlaintext_checked)
            // set turnon_
            bToggleButtonState(bHTML,"on");
          else
            // set turnoff_
            bToggleButtonState(bHTML,"off");
          break;
        case 1:
          if (AsPlaintext_checked)
            // set turnon_
            bToggleButtonState(bHTML,"on");
          else
            // set turnoff_
            bToggleButtonState(bHTML,"off");
          break;
        case 2:
          if (Sanitized_checked)
            // set turnon_
            bToggleButtonState(bHTML,"on");
          else
            // set turnoff_
            bToggleButtonState(bHTML,"off");
          break;
        default:
          break;
      }
    }

    var bImage = document.getElementById("ToggleImages");
    if(bImage) {
			var hideImages = nsPreferences.getBoolPref("mailnews.message_display.disable_remote_image", false);
      if(hideImages) {
        // set to turnon_
        bToggleButtonState(bImage,"on");
      } else {
        // set to turnoff_
        bToggleButtonState(bImage,"off");
      }
    }

    var bHeaders = document.getElementById("bHeaders");
    if(bHeaders) {
      var fullHeaders = nsPreferences.getIntPref("mail.show_headers", 1);
      if(fullHeaders == 1) {
        // set to turnon_
        bToggleButtonState(bHeaders,"on");
      } else {
        // set to turnoff_
        bToggleButtonState(bHeaders,"off");
      }
    }
  } catch (e) {}
}

var bButtonUpdateObserver = {
  observe: function(subject,topic,data) {
    if(topic == "nsPref:changed")
      bUpdateButtons();
  }
};

function bViewSource(event) {
  MsgViewPageSource();
}

function bToggleHeaders() {
  var fullHeaders = nsPreferences.getIntPref("mail.show_headers", 1);
  if(fullHeaders == 1) {
    MsgViewAllHeaders();
  } else {
    MsgViewNormalHeaders();
  }
}

function bOnloadForMainMessage() {
  var bPrefService = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranchInternal);
  bPrefService.addObserver("mailnews.message_display.disable_remote_image", bButtonUpdateObserver, false);
  bPrefService.addObserver("mailnews.display.prefer_plaintext", bButtonUpdateObserver, false);
  bPrefService.addObserver("mailnews.display.html_as", bButtonUpdateObserver, false);
  bPrefService.addObserver("mailnews.display.disallow_mime_handlers", bButtonUpdateObserver, false);
  bPrefService.addObserver("mail.show_headers", bButtonUpdateObserver, false);

  bUpdateButtons();
}

function bOnunloadForMainMessage() {
  var bPrefService = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranchInternal);
  bPrefService.removeObserver("mailnews.message_display.disable_remote_image", bButtonUpdateObserver);
  bPrefService.removeObserver("mailnews.display.prefer_plaintext", bButtonUpdateObserver);
  bPrefService.removeObserver("mailnews.display.html_as", bButtonUpdateObserver);
  bPrefService.removeObserver("mailnews.display.disallow_mime_handlers", bButtonUpdateObserver);
  bPrefService.removeObserver("mail.show_headers", bButtonUpdateObserver);
}
